// 生成当前时间
const NowTime = () => {
  const oDate = new Date()
  const y = oDate.getFullYear()
  const M = oDate.getMonth() + 1
  const d = oDate.getDate()
  const h = oDate.getHours()
  const m = oDate.getMinutes()
  const s = oDate.getSeconds()
  return `${y}-${M}-${d} ${h}:${m}:${s}`
}

// 默认的mark样式
let cssText = `
  position: fixed;
  opacity: .15;
  font-size: 12px;
  -webkit-transform: rotate(-15deg);
  -moz-transform: rotate(-15deg);
  -ms-transform: rotate(-15deg);
  -o-transform: rotate(-15deg);
  transform: rotate(-15deg); 
  -webkit-user-select: none;
  -moz-user-select: none;
  -ms-user-select: none;
  user-select: none;
  padding: 25px 0 25px 5px;
  box-sizing: border-box;
  white-space: nowrap;
  pointer-events: none;
  z-index: 999999;
`
// 初始化默认展示值
let wmContent = `${NowTime()} zhaopin.com`

// 初始化step
let stepX = 280
let stepY = 130

let trailList = []
// 范围
let markSize = {
  height: document.body.clientHeight || '',
  width: document.body.clientWidth || '',
  top: 0,
  left: 0,
}
const clearOldMark = (el, markList) => {
  for (let dom of markList) {
    setTimeout(() => {
      dom.remove()
    }, 0)
  }
}

const innerMark = (el, binding) => {
  if (binding.value && !binding.value.type) {
    markSize = el.getBoundingClientRect()
  } else {
    markSize = {
      height: document.body.clientHeight || '',
      width: document.body.clientWidth || '',
      top: 0,
      left: 0,
    }
  }
  // 查看XY初始值
  if (binding.value && binding.value.Y) {
    markSize.top = binding.value.Y
  }
  if (binding.value && binding.value.X) {
    markSize.left = binding.value.X
  }
  let htmlString = ''
  // 是否只需要一个水印
  if (binding.value && binding.value.isOnlyMark) {
    const fixedTop = (binding.value && binding.value.fixedTop) || 20
    const fixedLeft = (binding.value && binding.value.fixedLeft) || 35
    const fixedRight = (binding.value && binding.value.fixedRight) || 35
    const fixedBottom = (binding.value && binding.value.fixedBottom) || 20
    htmlString =  binding.value && binding.value.fixedTop
      ? `<div class="watermark-directive" style="position: absolute !important;${cssText}left:${fixedLeft}px;top:${fixedTop}px;">${wmContent}</div>`
      : `<div class="watermark-directive" style="position: absolute !important;${cssText}right:${fixedRight}px;bottom:${fixedBottom}px;">${wmContent}</div>`
  } else {
    const maxWidth = markSize.width
    const maxHeight = markSize.height
    for (let i = 0; i * stepY < maxHeight; i++) {
      for (let j = 0; j * stepX < maxWidth; j++) {
        if (trailList.indexOf('' + j * stepX + i * stepY) === -1) {
          trailList.push('' + j * stepX + i * stepY)
          i % 2
            ? htmlString += `<div class="watermark-directive" style="${cssText}left:${markSize.left + j * stepX + 100}px;top:${markSize.top + i * stepY}px;">${wmContent}</div>`
            : htmlString += `<div class="watermark-directive" style="${cssText}left:${markSize.left + j * stepX}px;top:${markSize.top + i * stepY}px;">${wmContent}</div>`
        }
      }
    }
  }
  if (binding.value && binding.value.type) {
    document.body.insertAdjacentHTML('beforeend', htmlString)
  } else {
    el.insertAdjacentHTML('beforeend', htmlString)
  }
}

const WatermarkDirective = {
  bind (el, binding) {
    // 清空之前的mark
    if (binding.value && binding.value.isClear) {
      const markList = document.getElementsByClassName('watermark-directive')
      markList.length && clearOldMark(el, markList)
    }
    // 初始化清空
    trailList = []
    // 初始化是否传入mark值
    if (binding.value && binding.value.mark) {
      wmContent = binding.value && binding.value.mark || `${NowTime()} zhaopin.com`
    }
    // 初始化xy间隔
    if (binding.value && binding.value.stepX) {
      stepX = binding.value.stepX < stepX ? stepX : binding.value.stepX
    }
    if (binding.value && binding.value.stepY) {
      stepY = binding.value.stepY < stepY ? stepY : binding.value.stepY
    }
    setTimeout(() => {
      innerMark(el, binding)
    }, 0)
  },
  update (el, binding) {
    setTimeout(() => {
      innerMark(el, binding)
    }, 0)
  }
}

const Watermark = {
  install (Vue) {
    Vue.directive('watermark', WatermarkDirective)
  },
  name: 'watermark'
}

export {
  Watermark,
  WatermarkDirective
}
